function [g]=NL_G_ForceBasedAlgo(g,damping,timestep,m,lequilibrium,kc,kh,tkel,ind)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=9;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[go]=NL_G_ForceBasedAlgo(g,d,t,m,l,kc,kh,tk,i)";
		help('NL_G_ForceBasedAlgo');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	ind=2;
	scf(ind);//creation of a graphic window
	clf(ind);
	f=gcf();
	f.figure_name='Force-Directed Layout';
	//f.pixmap='on'; //set the pixmap mode
	plot2d(0,0,-1,"011"," ",style=5,rect=[0,0,1000,1000]);//creation of the network boundaries
	xgrid;
	r=20;
	NL_M_GraphAnimation(g.node_x,g.node_y,r,5,ind);//fixed nodes in red (5)
	he=g.head;
	ta=g.tail;
	n=length(g.node_x);
	l=length(g.head);
	vxnodes=zeros(1,n);
	vynodes=zeros(1,n);
	xnodes=g.node_x;
	ynodes=g.node_y;
	for j=1:l
  		xpolys([xnodes([he(j) ta(j)])+r/2]',[ynodes([he(j) ta(j)])-r/2]',1);//display the network links
	end
	//show_pixmap();//display
	delta_kinetic_energy=10^9;
	d=10;
	qi=1;
	qj=1;
	nx=xnodes;
	ny=ynodes;
	xnodes0=xnodes;//original values
	ynodes0=ynodes;
	total_kinetic_energy=10^9;
	dtke=total_kinetic_energy;
	oldtke=total_kinetic_energy;
	while (abs(dtke)>tkel)
		total_kinetic_energy=0;
		//delete(f.children.children(1:$-2));//remove old links before the performance of the current topology
		netforcex=zeros(1,n);
		netforcey=zeros(1,n);
		for i=1:n
			//fr=f.children.children($-1).children(n-i+1);//node i
			v=1:n;
			v=NL_F_RemoveFirstOcc(v,i);//all nodes except node i
			for j=v
				[Cx,Cy]=NL_G_CoulombForce(kc,qi,qj,i,j,xnodes,ynodes);
				netforcex(i)=netforcex(i)+Cx;
				netforcey(i)=netforcey(i)+Cy;  
			end
			Neigh=NL_G_NodeNeighbors(i,g);
			for k=Neigh
				[Hx,Hy]=NL_G_HookeForce(kh,i,k,xnodes,ynodes,lequilibrium);
				netforcex(i)=netforcex(i)+Hx;
				netforcey(i)=netforcey(i)+Hy;  
			end 
			//without damping, it moves forever, 0 < damping < 1
			vxnodes(i)=(vxnodes(i)+timestep*sqrt(netforcex(i)*netforcex(i)+netforcey(i)*netforcey(i)))*damping;
			vynodes(i)=(vynodes(i)+timestep*sqrt(netforcex(i)*netforcex(i)+netforcey(i)*netforcey(i)))*damping;
			total_kinetic_energy=total_kinetic_energy+m*(vxnodes(i)*vxnodes(i)+vynodes(i)*vynodes(i));	
		end

		//new position of nodes
		for i=1:n
			xnodes(i)= xnodes(i)+timestep*netforcex(i);
			ynodes(i)= ynodes(i)+timestep*netforcey(i);
			f.children.children($-1).children(n-i+1).data(1:2)= [xnodes(i) ynodes(i)];
		end

		for j=1:l
			f.children.children(l-j+1).children.data=[[xnodes([he(j) ta(j)])+r/2]',[ynodes([he(j) ta(j)])-r/2]'];
			//link i f.children.children(2).children.data
		//	xpolys([xnodes([he(j) ta(j)])+r/2]',[ynodes([he(j) ta(j)])-r/2]',1);//display the network links
		end
		//show_pixmap();//display
		dtke=total_kinetic_energy-oldtke;
		oldtke=total_kinetic_energy;
	end
	g.node_x=xnodes;
	g.node_y=ynodes;
	//f.pixmap='off'; //set the pixmap mode
endfunction
