function [buf,bufs,at,tt,it,sw,rt,routep,probch,pch]=NL_I_TrafficSimulation(g,rt1,rt2,rt3,rt4,rt5,pt,n,L,bs,tpmax,swmin,rtmin,rtmax,nd,nf,tlim,cpmax,ct,cs,cpt,closs,cack,T,pr,Tr,iw)
	[lhs,rhs]=argn();
	lhsn=10;
	rhsn=27;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[buf,bufs,at,tt,it,sw,rt,routep,probch,pch]=NL_I_TrafficSimulation(g,rt1,rt2,rt3,rt4,rt5,pt,n,L,bs,tpmax,swmin,rtmin,rtmax,nd,nf,tlim,cpmax,ct,cs,cpt,closs,cack,T,pr,sa,Tr,iw)";
		help('NL_I_TrafficSimulation');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	buf=[];//initialization of the buffer occupancy of each node of the reception network
	bufs=[];//initialization of the buffer occupancy of each node of the emission network
	gl=length(g.head);//quantity of network links
	[probroute]=NL_I_RouteManagerInit(rt1,rt2,rt3,rt4,rt5,pt,n,L);//initialization of the route manager
	probrouteinit=probroute;//backup of the route manager initial state
	[network]=NL_I_NetworkMatrixInit(n,bs);//initialization of the reception network matrix
	[networks]=NL_I_NetworkMatrixInit(n,bs);//initialization of the emission network matrix
	[rp]=NL_I_PacketManagerInit(tpmax);//initialization of the packet manager
	[swi,rti]=NL_I_TCPNetworkInit(n,swmin,rtmin);//initialization of the TCP parameters values for each network node (also valid for MPTCP).
	[vs]=NL_G_ConnectionNeighbors(g,rt1,nd,nf,n);//extraction of the neighborhood of the connection between the nodes nd and nf
	vs=vs';
	v=vs;
	at=[];//initialization of the arrival time process of the defined connection packets
	tt=[];//initialization of the travel time process of the defined connection packets
	it=[];//initialization of the packet index process of the defined connection packets
	routep=[];//initialization of the route process of the defined connection packets
	probch=[];//initialization of the route manager change process
	pch=[];//initialization of the route manager change process of the defined connection
	sw=[];//initialization of the sliding window process of the defined connection
	rt=[];//initialization of the retransmission process of the defined connection
	pr=0.9;//probability threshold
	winId=waitbar('Traffic Simulation');
	format('v',6);
	is=1;//initialization of the index for the defined connection 
	while(is<bs)//fullfil the buffer of the source node inside the emission network matrix
		[rp,p,is]=NL_I_Connection(rp,nd,nf,cs,cpt,is);
		[networks,rp]=NL_I_AddPackets2Network(p,networks,rp);
	end
	t=1;//initialization of the simulation time
	dt=getdate();
	seed=dt(10);
	rand('seed',seed);//initialization of the random values generator
	f=NL_G_ShowGraph(g,iw);//initial graph
	//f.pixmap='on'; //set the pixmap mode
	f.figure_name='NL_I_TrafficSimulation';
	while (t<tlim)&(length(at)<>cs)
		waitbar(t/tlim,winId);//display the waiting bar in respect with the simulation duration
		if (modulo(t-1,Tr*T)==0)//periodic generation of new connections 
			[networks,rp]=NL_I_ConnectionManager(nd,n,bs,cpmax,networks,rp,ct,pr);
		end
		if (networks(nd,$)<bs)//create a new packet of the connection under studies if it is allowed
			[rp,p,is]=NL_I_Connection(rp,nd,nf,cs,cpt,is);
			[networks,rp]=NL_I_AddPackets2Network(p,networks,rp);
		end
		[swi,rti,network,networks,rp]=NL_I_Emission2Reception(swi,rti,rtmax,network,networks,n,bs,rp,t,probroute);//data transfer between the emission network towards the reception network 
		for vb=1:Tr
			[lfo,swi,rti,probroute,network,networks,rp,it,at,tt,routep,probch]=NL_I_Reception2Reception(g,swi,bs,rti,rtmax,rt1,rt2,rt3,rt4,rt5,probroute,closs,cack,network,networks,n,rp,t,nd,nf,it,at,tt,routep,probch,probrouteinit);//data propagation inside the reception network
			v=[v network(vs,$)];//update of v
			sw=[sw swi(nd)];//update of sw
			rt=[rt rti(nd)];//update of rt
			buf=[buf network(:,$)];//update of buf
			bufs=[bufs networks(:,$)];//update of bufs
			pch=[pch [probroute((nd-1)*n+nf,1:5)]'];//update of pch
			[g]=NL_I_NetworkState(g,gl,lfo,[network(:,$)]',10,bs);//display the network load
			[f]=NL_I_ShowTrafficChange(g,f);
			//f.pixmap='on'; //set the pixmap mode
			//show_pixmap();
			t=t+1;
		end
	end
	//f.pixmap='off';
	close(winId);//close the waiting bar
	scf(iw+1);
	clf(iw+1);
	[path]=NL_R_PathERT(rt1,nd,nf,n);//shortest path between nd and nf
	[a b]=size(v);
	leg=[];
	for i=1:length(path)
		ind=find(v(:,1)==path(i));
		plot2d(1:b-1,v(ind,2:$),style=i,rect=[1,1,b-1,bs]);
		leg=[leg 'node '+string(path(i))];
	end
	legends(leg,1:i,with_box=%f,opt="lr");
	f=get("current_figure");
	f.figure_name=("Connection Buffer Occupancy");
	scf(iw+2);
	clf(iw+2);
	plot2d(1:b-1,sw,rect=[1,1,b-1,bs]);
	f=get("current_figure");
	f.figure_name=("Sliding Window of the Connection");
	scf(iw+3);
	clf(iw+3);
	plot2d(1:b-1,rt,rect=[1,1,b-1,rtmax]);
	f=get("current_figure");
	f.figure_name=("Retransmission Time of the Connection");
	iat=at(2:$)-at(1:$-1);
	scf(iw+4);
	clf(iw+4);
	plot2d(1:length(iat),iat);
	f=get("current_figure");
	f.figure_name=("Inter-Arrival Time at the Destination Node Nf");
	scf(iw+5);
	clf(iw+5);
	plot2d3(it,tt);
	f=get("current_figure");
	f.figure_name=("Travel Time of Connection Packets");
endfunction

