function [A]=NL_R_ARCCongestionLR(A,i,pm,d,typ)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=5;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[A]=NL_R_ARCCongestionLR(A,i,pm,d,typ)";
		help('NL_R_ARCCongestionLR');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	pl=A(i,$-2);
	pr=A(i,$-1);
	[lA cA]=size(A);
	if (typ==0) then    //multiplicatif
		if (d==2) then //congestion on right
			npr=pr*pm;
			npl=1-npr;
		else//d==1 congestion on left
			npl=pl*pm;
			npr=1-npl;
		end
		A(i,$-2)=npl;
		A(i,$-1)=npr;
	else//additif
		if (d==2) then //congestion on right
			npr=max([pr-pm 0]);
			npl=1-npr;
			if (npl==1) then
				//cursor location must be changed (mid+ congestion)-> the next node of the arc on the right where a upper arc is joining
				//is is right?
				arci=A(i,1:A(i,$));//current arc
				icursori=A(i,$-3);//
				cursori=A(i,icursor);//
				//cursori=A(i,$-3);//current cursor
				//icursori=find(arci==cursori);
				nextcurs=%F;//boolean is becoming true when we find the next node where an arc is joining
				for ll=icursori+1:length(arci)//add perhaps a condition because icursor+1 cand be the exit node (length(arc))?
					cand=arci(ll);//node in consideration for the next cursor location
					for ca=1:lA
						exitarc=[A(ca,1) A(ca,A(ca,$))];
						if (find(exitarc==cand)<>[]) then
							nextcurs=%T;
							break;
						end
					end
					if (nextcurs==%T)
						break;
					end
				end
				//ll is the right index
				//A(i,$-3)=arci(ll);
				A(i,$-3)=ll;//
				//new distribution 50 left 50 right
				//is it optimal?
				npr=0.5;
				npl=0.5;
			end
		elseif (d==1)//d==1 congestion on left
			npl=max([pl-pm 0]);
			npr=1-npl;
			if (npr==1) then
				//cursor location must be changed (mid+ congestion)-> the next node of the arc on the left where a upper arc is joining
				//is is right?
				arci=A(i,1:A(i,$));//current arc
				icursori=A(i,$-3);
				cursori=arci(icursori)
				//cursori=A(i,$-3);//current cursor
				//icursori=find(arci==cursori);
				nextcurs=%F;//boolean is becoming true when we find the next node where an arc is joining
				for ll=icursori-1:-1:1//add perhaps a condition because icursor-1 cand be the exit node: first node of the arc?
					cand=arci(ll);//node in consideration for the next cursor location
					for ca=1:lA
						exitarc=[A(ca,1) A(ca,A(ca,$))];
						if (find(exitarc==cand)<>[]) then
							nextcurs=%T;
							break;
						end
					end
					if (nextcurs==%T)
						break;
					end
				end
				//ll is the right index
				//A(i,$-3)=arci(ll);
				A(i,$-3)=ll;// 
				//new distribution 50 left 50 right
				//is it optimal?
				npr=0.5;
				npl=0.5;
			end
		else// d=0 -> congestion on left and right of the same arc
			arci=A(i,1:A(i,$));//current arc
			//find arcs connected to the current arc
			connectedarc=[];
			for ii=1:length(arci)
				cand=arci(ii);//current node of the arc where double congestion occurs
				//i is the arc under consideration
				for ca=1:lA
					if (ca<>i) then
						exitarc=[A(ca,1) A(ca,A(ca,$))];
						if (find(exitarc==cand)<>[]) then
							connectedarc=[connectedarc ca];
						end
					end
				end
			end
			connectedarc=unique(connectedarc);
			//modification of parameters of connected arcs
			//we put pr and pr to 0.5 but other solutions need to be study
			// location of their cursor may also be moved to thei first intersection to another arc-> so that the traffic is distributed 
			for ica=1:length(connectedarc)
				A(connectedarc(ica),$-2)=0.5;//pl
				A(connectedarc(ica),$-1)=0.5;//pr
			end
			npl=0.5;
			npr=0.5;
		end
		A(i,$-2)=npl;
		A(i,$-1)=npr;
	end
endfunction
