function [mat1,mat2,nod1,nod2,arc,p1,p2]=NL_R_ARCFirstARC(g,s,Heir1,Heir2)
	[lhs,rhs]=argn();
	lhsn=7;
	rhsn=4;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[mat1,mat2,nod1,nod2,arc,p1,p2]=NL_R_ARCFirstARC(g,s,Heir1,Heir2)";
		help('NL_R_ARCFirstARC');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	pred1=zeros(1,g.node_number);
	dist1=100000000*ones(1,g.node_number);
	dist1(s)=0;
	dist2=100000000*ones(1,g.node_number);
	dist2(s)=0;
	pred2=pred1;
	[mat,np]=NL_R_ARCRootInit(g,s);
	mat1=mat(find(mat(:,2)==Heir1),:);
	mat2=mat(find(mat(:,2)==Heir2),:);
	np1=1;
	np2=1;
	intersection=%F;
	S1=[Heir1];
	S2=[Heir2];
	pred1(Heir1)=s;
	dist1(Heir1)=NL_F_DistanceNiNj(s,Heir1,g.node_x,g.node_y);
	pred2(Heir2)=s;
	dist2(Heir2)=NL_F_DistanceNiNj(s,Heir2,g.node_x,g.node_y);
	//check if a S1 and S2 can be connected with a direct link	
	if (NL_G_Nodes2Path([S1 S2],g)<>[])
		intersection=%T;
		nod1=Heir1;
		nod2=Heir2;
		p1=[s Heir1];
		p2=[s Heir2];
		arc=[s Heir1 Heir2 s];
	end
	while (intersection==%F)
		[mat1,np1]=NL_R_ARCRootIter(g,s,mat1,np1);//flood from Heir1
		[mat2,np2]=NL_R_ARCRootIter(g,s,mat2,np2);//flood from Heir2
		//update pred
		pathlength=mat1(1,$-1);
		cur1=mat1(:,pathlength);
		cur2=mat2(:,pathlength);
		i1=find(pred1(cur1)==0);//first arrival in a node
		pred1(cur1(i1))=[mat1(i1,pathlength-1)]';
		dist1(cur1(i1))=[mat1(i1,$)]';//
		i2=find(pred2(cur2)==0);//first arrival in a node
		pred2(cur2(i2))=[mat2(i2,pathlength-1)]';
		dist2(cur2(i2))=[mat2(i2,$)]';//
		//verification of intersection
		scur1=unique(cur1');
		scur2=unique(cur2');
		lscur1=length(scur1);
		lscur2=length(scur2);		
		cur=gsort([scur1 scur2],'c','i');
		lcur=length(cur);
		scur=unique(cur);
		lscur=length(scur);
		if (lscur<>lcur) //direct intersection
			intersection=%T;
			inds12=cur(2:$)-cur(1:$-1);
			inds12_0=find(inds12==0);
			inter12=cur(inds12_0);//intersection can be more than 2 nodes
			nod1=inter12;
			nod2=[];
			//select the shortest arc
			arcdist=dist1(nod1)+dist2(nod1);
			[sia sib]=min(arcdist);
			sinter=nod1(sib);//selected intersection
			p1=NL_R_PredecessorRoute(pred1,dist1,s,sinter);
			p1=p1($:-1:1);
			p2=NL_R_PredecessorRoute(pred2,dist2,s,sinter);
			arc=[p1 p2(2:$)];
			p2=p2($:-1:1);
				
		else //presence of a direct link between s1 and s2
				nod1=[];
				nod2=[];
				for i=1:lscur1				
					for j=1:lscur2
						if (NL_G_Nodes2Edge(g,scur1(i),scur2(j))<>[])
							nod1=[nod1 scur1(i)];
							nod2=[nod2 scur2(j)];
						end
					end
				end
				if (nod1<>[])
					intersection=%T;
					p1=NL_R_PredecessorRoute(pred1,dist1,s,nod1);
					p1=p1($:-1:1);
					p2=NL_R_PredecessorRoute(pred2,dist2,s,nod2);
					arc=[p1 p2];
					p2=p2($:-1:1);
				end
		end
	end
endfunction
