function [paths,cpaths]=NL_R_ARCMultiPath(cmatarc,s,d,l1,l2,r1,r2,g)
	[lhs,rhs]=argn();
	lhsn=2;
	rhsn=8;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[paths,cpaths]=NL_R_ARCMultiPath(cmatarc,s,d,l1,l2,r1,r2,g)";
		help('NL_R_ARCMultiPath');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	[l c]=size(cmatarc);
	//arcs where d belongs to 
	iarc=[]
	for i=1:l
		arc=cmatarc(i,1:cmatarc(i,$));
		ii=find(arc==d);
		if (ii<>[])
			iarc=[iarc i];
			break;//only keep the first arc
		end
	end
	ik=0;
	paths=zeros(g.node_number,g.node_number+2);
	cpaths=paths;
	//initialization of paths
	for k=1:length(iarc(1))//iarc(k)//only the first arc
		ic=iarc(k);
		arccourant=cmatarc(ic,1:cmatarc(ic,$));
		[p1,p2]=NL_R_ARCSubPaths(arccourant,d);
		if (p1<>[])
			ik=ik+1;
			lp1=length(p1);
			paths(ik,1:lp1)=p1;
			cpaths(ik,1:lp1)=l1;//left
			paths(ik,$)=lp1;
			if (p1($)==s)
				paths(ik,$-1)=1;
			end
		end
		if (p2<>[])
			ik=ik+1;
			lp2=length(p2);
			paths(ik,1:lp2)=p2;
			cpaths(ik,1:lp2)=r1;//right
			paths(ik,$)=lp2;
			if (p2($)==s)
				paths(ik,$-1)=1;
			end
		end
	end
	//boolean no more paths
	nop=(sum(paths(1:ik,$-1))==ik);
	while (nop==%F)
		pathsold=paths;
		cpathsold=cpaths;
		//propagation of paths
		pind=1:ik;//possible index
		inc=find(pathsold(pind,$-1)==0);//packet that doesn't reach the source
		//pind(inc(i)): index of packets
		for i=1:length(inc)
			nc=paths(pind(inc(i)),pathsold(pind(inc(i)),$));
			//arc of interestpaths
			iarc=[];
			for k=1:l
				arc=cmatarc(k,1:cmatarc(k,$));
				ii=find(arc==nc);
				if (ii<>[])
					iarc=[iarc k];
					break;//only keep the first arc
				end
			end
			arccourant=cmatarc(iarc,1:cmatarc(iarc,$));
			[p1,p2]=NL_R_ARCSubPaths(arccourant,nc);
			id=0;
			indpa=pind(inc(i));//line index
			oldpath=paths(indpa,1:pathsold(indpa,$));//current path
			coldpath=cpaths(indpa,1:pathsold(indpa,$));//color path (0,1) 
			oldl=pathsold(indpa,$);//length of the current path
			if (p1<>[])
				id=id+1;
				//concatenation to the line
				newpath=[oldpath p1(2:$)];//new path
				if (coldpath($)==l1)
					ll=l2;
				else
					ll=l1;	
				end
				cnewpath=[coldpath ll*ones(1,length(p1(2:$)))];
				lnewpath=length(newpath);
				paths(indpa,1:lnewpath)=newpath;	
				paths(indpa,$)=lnewpath;
				cpaths(indpa,1:lnewpath)=cnewpath;
				if (p1($)==s)
					paths(indpa,$-1)=1;
				end
			end
			if (p2<>[])
				if (id==1)
				//add a new line
					ik=ik+1;
					newpath=[oldpath p2(2:$)];//new path
					if (coldpath($)==r1)
						rr=r2;
					else
						rr=r1;	
					end
					cnewpath=[coldpath rr*ones(1,length(p2(2:$)))];
					lnewpath=length(newpath);
					paths(ik,1:lnewpath)=newpath;	
					paths(ik,$)=lnewpath;
					cpaths(ik,1:lnewpath)=cnewpath;
					if (p2($)==s)
						paths(ik,$-1)=1;
					end		
				else
					//concatenation
					newpath=[oldpath p2(2:$)];//new path
					if (coldpath($)==r1)
						rr=r2;
					else
						rr=r1;	
					end
					cnewpath=[coldpath rr*ones(1,length(p2(2:$)))];
					lnewpath=length(newpath);
					paths(indpa,1:lnewpath)=newpath;	
					paths(indpa,$)=lnewpath;
					cpaths(indpa,1:lnewpath)=cnewpath;
					if (p2($)==s)
						paths(indpa,$-1)=1;
					end
				end
			end
			//update of nop
			nop=(sum(paths(1:ik,$-1))==ik);
		end
	end
	paths=[paths(1:ik,1:max(paths(:,$))) paths(1:ik,$)];
	cpaths=[cpaths(1:ik,1:max(paths(:,$)))];
endfunction
