function [A,T,L]=NL_R_ARCTrafficManager(A,S,ST,Tmax,Tcong,typ,pm,dmax,g,wi,wj)
	[lhs,rhs]=argn();
	lhsn=3;
	rhsn=11;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[A,T,L]=NL_R_ARCTrafficManager(A,S,ST,Tmax,Tcong,typ,pm,dmax,g,wi,wj)";
		help('NL_R_ARCTrafficManager');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	//S list of nodes where traffic is generated
	//ST for each of these nodes, we provide the quantity of traffic generated
	//traffic distribution before A update
	T=[];
	for is=1:length(S)
		[Lis]=NL_R_ARCTrafficNode(A,S(is),g);
		T=T+ST(is)*Lis;
	end
	[gtri]=NL_R_ARCTrafficPlot(A,T,Tmax,dmax,g,wi);
	[congarc,dircongarc]=NL_R_ARCCongestionDetect(T,Tcong,A,g);//arc index where there is congestion
	//update of A if there is congestion
	if (congarc<>[]) then
		for ic=1:length(congarc)
			[A]=NL_R_ARCCongestionLR(A,congarc(ic),pm,dircongarc(ic),typ);
		end
	end
	//traffic distribution after A update
	T=[];
	L=[];
	for is=1:length(S)
		[Lis]=NL_R_ARCTrafficNode(A,S(is),g);
		L=[L;Lis];
		T=T+ST(is)*Lis;
	end
	[gtrk]=NL_R_ARCTrafficPlot(A,T,Tmax,dmax,g,wj);
endfunction

