function [rt]=NL_R_BellmanFordRT(g)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=1;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[rt]=NL_R_BellmanFordRT(g)";
		help('NL_R_BellmanFordRT');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	node_n=length(g.node_x);
	nlo=ceil(sqrt(node_n));
	//[d,p] = graph_diameter(g);
	rt=zeros(node_n*node_n,2*nlo);
	winId=waitbar('Routing Table');
	count=0;
	tot=(node_n)*(node_n-1)/2
	format('v',6);
	for i=1:node_n
		[dist,pred]=NL_R_BellmanFord(g,i);
		for j=i+1:node_n
			path=NL_R_PredecessorRoute(pred,dist,i,j);
			[path]=NL_F_ReverseVector(path);
			l=length(path);
			rt((i-1)*node_n+j,1)=l;
			rt((i-1)*node_n+j,2:length(path)+1)=path;
			rt((j-1)*node_n+i,1)=l;
			rt((j-1)*node_n+i,2:length(path)+1)=NL_F_ReverseVector(path);
			count=count+1;
			waitbar(min(count/tot,1),winId);
		end
	end
	winclose(winId);
endfunction
