function [dnodes,dnodesn]=NL_R_DijkstraMapSourcesN(g,source,w)
	[lhs,rhs]=argn();
	lhsn=2;
	rhsn=3;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[dnodes,dnodesn]=NL_R_DijkstraMapSourcesN(g,source,w)";
		help('NL_R_DijkstraMapSourcesN');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	[dist,distv]=NL_G_GraphDegreeDist(g);
	n=length(g.node_x);
	l=length(g.head);
	tnodes_set=1:n;
	tdnodes=[];
	tdnodesn=[];
	winId=waitbar('topology discovery');
	inddist=find(distv<>1);
	topo=distv(inddist);
	ltopo=length(inddist);
	for k=1:length(source)
		tnodes_set=NL_F_RemoveFirstOcc(tnodes_set,source(k));
	end
	nodes_set=tnodes_set;
	dnodes=[];
	dnodesn=[];
	ns=length(source);
	for i=1:n-1-ns
		[cnode,nodes_set]=NL_F_RandVectorNoRepl(nodes_set);
		int_dnodes=[];    
		for m=1:ns
			[path]=NL_R_DijkstraNiNj(g,source(m),cnode);
			for j=1:length(path)
				if ((length(find(dnodesn==path(j)))==0) & (length(find(inddist==path(j)))<>0))
					int_dnodes=[int_dnodes path(j)];
				end
			end
		end
		int_dnodes=NL_F_Unity(int_dnodes);
		totn=dnodes($)+length(int_dnodes);
		dnodes=[dnodes totn];
		dnodesn=[dnodesn int_dnodes];
		s=i/(n-1-ns);
		waitbar(min(s,1),winId);
	end
	close(winId);
	scf(w);
	clf(w);
	ind=1/(n-1-ns)*[1:n-1-ns];
	plot2d(ind,dnodes/ltopo,rect=[0 0 1 1]);
	xtitle('Topology discovery d>1','normalized research','normalized topology recovery');
	xgrid(2);
endfunction
