function [out]=NL_S_AESEncryption(s,in)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=2;
	if ((lhs<>lhsn) & (rhs<>rhsn))
		message="[out]=NL_S_AESEncryption(s,in)";
		help('NL_S_AESEncryption');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	// AES ENCRYPTION    Encrypt 16-bytes vector.
	// s:                AES structure
	// in:               input 16-bytes vector (plaintext) -> [0:255]
	// out:              output 16-bytes vector (ciphertext)

	// 16 -> 4 x 4
	state = matrix(in, 4, 4);
	// Initial round : AddRoundKey keyexp(1:4)
	state = bitxor(state, (s.keyexp(1:4, :))');
	// Loops (s.rounds - 1) rounds
	for i = 1:(s.rounds - 1)
		// SubBytes - lookup table
		//[state]=NARVAL_S_AES_SubBytes(s.s_box,state);
		state = s.s_box(state + 1);
		// ShiftRows
		state = NL_S_AESShiftRows(state);
		// MixColumns
		state = NL_S_AESMixColumns(state, s);
		// AddRoundKey keyexp(i*4 + (1:4))
		state = bitxor(state, (s.keyexp((1:4) + 4*i, :))');
	end
	// Final round
	// SubBytes - lookup table
	//[state]=NARVAL_S_AES_SubBytes(s.s_box,state);
	state = s.s_box(state + 1);
	// ShiftRows
	state = NL_S_AESShiftRows(state);
	// AddRoundKey keyexp(4*s.rounds + (1:4))
	state = bitxor(state, (s.keyexp(4*s.rounds + (1:4), :))');
	// 4 x 4 -> 16
	out = matrix(state, 1, 16);
endfunction
