function [expkey]=NL_S_AESKeyExpansion(key, s_box, rounds, mod_pol, aes_logt, aes_ilogt)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=6;
	if ((lhs<>lhsn) & (rhs<>rhsn))
		message="[expkey]=NL_S_AESKeyExpansion(key, s_box, rounds, mod_pol, aes_logt, aes_ilogt)";
		help('NL_S_AESKeyExpansion');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	// This is new faster version for all AES:
	rcon = 1;
	kcol = length(key)/4;
	expkey = (matrix(key,4,kcol))';
	// traverse for all rounds
	for i = kcol:(4*(rounds + 1) - 1)
		// copy the previous row of the expanded key into a buffer
		temp = expkey(i, :);
		// each kcol row
		if (pmodulo(i, kcol) == 0)
			// rotate word
			temp = temp([2 3 4 1]);
			// s-box transform
			temp = s_box(temp + 1);
			// xor
			temp(1) = bitxor(temp(1), rcon);
			// new rcon
			// faster version with log/ilog tables
			// note rcon is never zero here
			// rcon = aes_ilogt(pmodulo((aes_logt(rcon + 1) + aes_logt(2 + 1)), 255) + 1);
			rcon = aes_ilogt(pmodulo((aes_logt(rcon + 1) + 25), 255) + 1);
		else
			if ((kcol > 6) & (pmodulo(i, kcol) == 4))
				temp = s_box(temp + 1);
			end
		end
		// generate new row of the expanded key
		expkey(i + 1, :) = bitxor(expkey(i - kcol + 1, :), temp);
	end
endfunction
