function [out]=NL_S_ShiftRows(in, d)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[out]=NL_S_ShiftRows(in, d)";
		help('NL_S_ShiftRows');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	// ShiftRows cyclically shift the rows of the 4 x 4 matrix.
	//
	//   dir = 0 (to left)
	//  | 1 2 3 4 |
	//  | 2 3 4 1 |
	//  | 3 4 1 2 |
	//  | 4 1 2 3 |
	//
	//   dir ~= 0 (to right)
	//  | 1 2 3 4 |
	//  | 4 1 2 3 |
	//  | 3 4 1 2 |
	//  | 2 3 4 1 |
	if (d == 0)
		//left
		// use linear indexing in 2d array
		out = matrix(in([1 6 11 16 5 10 15 4 9 14 3 8 13 2 7 12]),4,4);
		// old safe method
		//     temp = reshape(in,16,1);
		//     temp = temp([1 6 11 16 5 10 15 4 9 14 3 8 13 2 7 12]);
		//     out = reshape(temp,4,4);
	else
		// right
		// use linear indexing in 2d array
		out = matrix(in([1 14 11 8 5 2 15 12 9 6 3 16 13 10 7 4]),4,4);
		// old safe method
		//     temp = reshape(in,16,1);
		//     temp = temp([1 14 11 8 5 2 15 12 9 6 3 16 13 10 7 4]);
		//     out = reshape(temp,4,4);
	end
endfunction
