function [XX]=NL_V_Convolution2D(X,H)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[XX]=NL_V_Convolution2D(X,H)";
		help('NL_V_Convolution2D');
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	//H must be a square matrix(2n+1)
	[l c]=size(X);
	[a b]=size(H);
	n=(a-1)/2;
	XX=zeros(l,c);
	for x=n+1:c-n
		for y=1+n:l-n
			XX(x,y)=sum(X(x-n:x+n,y-n:y+n).*H);
		end
	end
endfunction
